import { EMPTY } from '../observable/empty';
import { operate } from '../util/lift';
import { OperatorSubscriber } from './OperatorSubscriber';
export function takeLast(count) {
    return count <= 0
        ? function () { return EMPTY; }
        : operate(function (source, subscriber) {
            var buffer = [];
            source.subscribe(new OperatorSubscriber(subscriber, function (value) {
                buffer.push(value);
                count < buffer.length && buffer.shift();
            }, undefined, function () {
                for (var _i = 0, buffer_1 = buffer; _i < buffer_1.length; _i++) {
                    var value = buffer_1[_i];
                    subscriber.next(value);
                }
                subscriber.complete();
            }, function () {
                buffer = null;
            }));
        });
}
//# sourceMappingURL=takeLast.js.map